/////////////////////////////////////////////////////////////////////////
////                                                                 ////
//// RR2_USB_Cdc_Monitor.c                                           ////
////                                                                 ////
/////////////////////////////////////////////////////////////////////////

#include <18F4550.h>

#device adc=10;                  //Conversor A/D de 10 bits

#fuses HSPLL,NOWDT,NOPROTECT,NOLVP,NODEBUG,USBDIV,PLL5,CPUDIV1,VREGEN
#use delay(clock=48000000)  //quiz necesite cambiar a 20 MHz

#include ".\include\usb_cdc.h"

#rom int 0xf00000={1,2,3,4}

void main() {
   
   int i, j, k=0;
   int16 valor_digital[4][4];          //Valor digital obtenido del conversor A/D
   float valor_analogico[4][4];        //Valor analgico medido en el conversor A/D
   char recepcion;               //Dato recibido del PC
   int1 control=1;                 //falso o verdadero para mostrar tensin;
   setup_adc_ports(ALL_ANALOG);         //Definimos todos los pines como analgicos
   setup_adc(ADC_CLOCK_INTERNAL);//Definicin de la fuente de reloj para el A/D
   
   delay_ms(1000);
   usb_cdc_init();
   usb_init();
   while(!usb_cdc_connected()) {}

   do {
      usb_task();
      if (usb_enumerated()) {
        
         //Lectura del canal analgico
         
         printf(usb_cdc_putc, "\f"); //borra todo de la pantalla
         delay_ms(5);
         
         for (i=0;i<4;i++){
         for(j=0;j<4;j++){
         if(i==0 && j==0) k=0;
         else if(i==0 && j==1) k=1;
         else if(i==0 && j==2) k=2;
         else if(i==0 && j==3) k=3;
         else if(i==1 && j==0) k=4;
         else if(i==1 && j==1) k=5;
         else if(i==1 && j==2) k=6;
         else if(i==1 && j==3) k=7;
         else if(i==2 && j==0) k=8;
         else if(i==2 && j==1) k=9;
         else if(i==2 && j==2) k=10;
         else if(i==2 && j==3) k=11;
         else if(i==3 && j==0) k=12;
         else if(i==3 && j==1) k=13;
         else if(i==3 && j==2) k=13;
         else if(i==3 && j==3) k=13;
         set_adc_channel(k);           //Seleccin del canal analgico
         valor_digital[i][j]=read_adc();
         //valor_analogico[i][j]=5.0*valor_digital[i][j]/1024.0;
         valor_analogico[i][j]=valor_digital[i][j];
         }}
         //Si se ha recibido dato...
       
        if (usb_cdc_kbhit()){
            recepcion=usb_cdc_getc();  //lo lee
            //si es caracter vacio(barra espaciadora)enciende o apaga visualizacin
            if (recepcion==' ') control=control+1;
         }
        
         
         //Si control=1 envia a PC valor de tensin leido
         if (control==1){
         printf(usb_cdc_putc, "9999\r\n");
         for (i=0;i<4;i++){
         for(j=0;j<4;j++){
            printf(usb_cdc_putc, "%04.0f\t", valor_analogico[i][j] );
            if(j==3) {printf(usb_cdc_putc, "\r\n");}}}
         }
         //sino deja de enviarlo y limpia la pantalla del hyperterminal   
         /*else                                       
            printf(usb_cdc_putc, "\f ");        */

         delay_ms(5);
      }
   
   } while (TRUE);
}
